capture log close
log using matwork_test, replace text
version 13
clear all
set linesize 80
macro drop _all
set scheme s2color

//  task:
//  project:
local pgm    matwork_test
local dte    2014-08-10
local who    scott long
local tag    "`pgm' `who' `dte'"


// OR + DC in table

spex logit
listcoef

matrix ev = e(V)
matmath diagis = diag(ev), list transpose

matmath a = ev, list
matmath a = eb, list
margins, at(wc=(0 1))
matmath a = rv, list
matmath a = rb, list
matmath a = table, list


exit
/*
. mat list r(table)

r(table)[9,6]
                   b           z       P>|z|         e^b     e^bStdX
      k5  -1.3915672  -7.2504668   4.153e-13   .24868526   .48233123
    k618  -.06566776   -.9612643   .33641929   .93644193   .91697674
2.agecat  -.62676009  -3.0028319    .0026748   .53432015   .73697602
3.agecat  -1.2790776  -4.9236435   8.495e-07   .27829388   .58893154
    1.wc   .79771359   3.4807081   .00050009   2.2204582   1.4319118
    1.hc   .13588948   .66143538   .50833314   1.1455553   1.0686304
     lwg   .60990959   4.0445615   .00005242    1.840265   1.4309754
     inc  -.03505416  -4.2378026   .00002257   .96555312   .66507987
constant   1.0139993   3.5448471   .00039284           .           .

               SDofX
      k5   .52395904
    k618   1.3198739
2.agecat   .48694856
3.agecat   .41392745
    1.wc   .45004937
    1.hc   .48846937
     lwg   .58755643
     inc   11.634799
constant           .
*/
matrix listcoef = r(table)
matmath newtab = keep(listcoef), cols(1 3 4 5 6) list rows(1/9)
* drop constant till better way to add row to matrix

mchange, amount(sd)
matrix mchange = r(table)
matlist mchange

exit




//  #1

//  #2

//  #3

//  #4

log close
exit

NOTES:

//  #5

//  #6

//  #7

//  #8

//  #9

set trace off
capture log close
log using it, replace text
program drop _all
* format for list

program drop _all
capture log close
log using it, replace text
version 13
clear all
set linesize 80
macro drop _all
set scheme s2color

// OR + DC in table

spex logit
listcoef
/*
. mat list r(table)

r(table)[9,6]
                   b           z       P>|z|         e^b     e^bStdX
      k5  -1.3915672  -7.2504668   4.153e-13   .24868526   .48233123
    k618  -.06566776   -.9612643   .33641929   .93644193   .91697674
2.agecat  -.62676009  -3.0028319    .0026748   .53432015   .73697602
3.agecat  -1.2790776  -4.9236435   8.495e-07   .27829388   .58893154
    1.wc   .79771359   3.4807081   .00050009   2.2204582   1.4319118
    1.hc   .13588948   .66143538   .50833314   1.1455553   1.0686304
     lwg   .60990959   4.0445615   .00005242    1.840265   1.4309754
     inc  -.03505416  -4.2378026   .00002257   .96555312   .66507987
constant   1.0139993   3.5448471   .00039284           .           .

               SDofX
      k5   .52395904
    k618   1.3198739
2.agecat   .48694856
3.agecat   .41392745
    1.wc   .45004937
    1.hc   .48846937
     lwg   .58755643
     inc   11.634799
constant           .
*/
matrix listcoef = r(table)
matmath newtab = keep(listcoef), cols(1 3 4 5 6) list rows(1/9)
* drop constant till better way to add row to matrix

mchange, amount(sd)
matrix mchange = r(table)
matlist mchange

exit





exit

matmath me = keep(me), rows(1(2)l) list




exit
exit

matrix me = r(table)
matmath me = abs(me) // abs change
matcol  me n = mean, list name(mean_abs) // mean absolute
matmath me = keep(me), cols(l) list // keep only mean
matmath me = table, me, list


matrix me = r(table)
matmath me = keep(me), rows(1(2)l) list
exit

matmath me = abs(me) // abs change
matcol  me n = mean, list name(mean_abs) // mean absolute
matmath me = keep(me), cols(l) list // keep only mean
matmath me = table, me, list

exit

exit

//  mean discrete change

spex mlogit
mchange, stats(est)
matrix table = r(table)
matmath me = abs(table) // abs change
matcol  me n = mean, name(mean_abs) // mean absolute
matmath me = keep(me), cols(l) // keep only mean
matmath me = table, me, list

//  compare logit and probit

spex logit
matrix logit = r(table)'
matrix coleq logit = "logit"
matmath logit = drop(logit), rows(3 6 8) cols(2 5 6 7 8 9) list

spex probit
matrix probit = r(table)'
matrix coleq probit = "probit"
matmath probit = drop(probit), rows(3 6 8) cols(2 5 6 7 8 9) list

matmath ratio = logit / probit, list
matrix coleq ratio = "ratio"

matrix compare = logit, probit, ratio
matlist compare, format(%8.3f)

//  stats: accumulate all stats using row

matrix a = (11, 12, 13, 14) \ (21, 22, 23, 24) \ (31, 32, 33, 34)
mat rowna a = row1 row2 row3
mat colna a = col1 col2 col3 col4

matrow a n = sum, list name(sum) row(1 2 3)
matrow a n = min, list name(min) row(1 2 3)
matrow a n = max, list name(max) row(1 2 3)
matrow a n = mean, list name(mean) row(1 2 3) list
matrow a n = sd, list name(sd) row(1 2 3) list
matrow a n = var, list name(var) row(1 2 3) list




exit
//  matwork

* 33
matrix a = (11, 12, 13) \ (21, 22, 23) \ (31, 32, 33)
mat rowna a = ra1 ra2 ra3
mat colna a = ca1 ca2 ca3

* 4x3
matrix b = (11, 12, 13) \ (21, 22, 23) \ (31, 32, 33) \ (41, 42, 43)
mat rowna b = r:b1 r:b2 r:b3 r:b4
mat colna b = c:b1 c:b2 c:b3

matrix c1 = J(5,5,1)
matrix c2 = J(5,5,2)
matrix c3 = J(5,5,3)

matrix d1 = J(3,3,11)
matrix d2 = J(3,3,22)
matrix d3 = J(3,3,33)

//  row col number

matrix atmp = a
matrow atmp 1 = number, list // 1st row
matcol atmp p = number, list name(prior) // add prior row

//  +

matmath tmp = a + 1, list
matmath tmp = a + b, list
matmath tmp = a + a, list

//  -

matmath tmp = c3 - c2, list

//  /

matmath tmp = c2 / 2, list
matmath tmp = c1 / c3, list

//  *

matmath tmp = c2 * 2, list
matmath tmp = c1 * c3, list

//  ^

matmath tmp = c2 ^ 2, list
matmath tmp = c1 ^ c3, list

//  %of

matmath tmp = c1 %of c2, list
matmath tmp = c2 %of c3, list

//  %dif"

matmath tmp = c1 %dif c2, list
matmath tmp = c2 %dif c3, list

//  ,

matmath tmp = c2 , c3, list

//  ,,

matmath tmp = c2 ,, d3, list

//  \

matmath tmp = c2 \ c3, list

//  \\

matmath tmp = a \\ c3, list

//  sqrt sq log log10 exp  inv

matmath c = sqrt(a), list
matmath c = sq(a), list
matmath c = log(a), list
matmath c = log10(a), list
matmath c = exp(a), list
matmath c = inv(a), list


//  keep and drop
matmath c = keep(a), r(1 2 2 1) col(1) list
matmath c = drop(a), row(1/2) cols(1 2) list

log close
exit

matmath c = keep(b), r(1 2) col(1) list

exit

mat b = J(3,3,2) // 3x3
mat rowna a = ra1 ra2 ra3
mat colna a = ca1 ca2 ca3


exit

* combine
matmath c = a , b, list
matmath c = a \ b, list
matmath c = a ,, b, list
matmath c = a \\ b, list

exit





mat a = J(3,3,1) // 3x3
mat rowna a = ra1 ra2 ra3
mat colna a = ca1 ca2 ca3
mat b = J(3,4,2) // 3x4
mat rowna b = rb1 rb2 rb3
mat colna b = cb1 cb2 cb3 cb4


exit

*

matmath c = a , b
matmath c = a \ b
matmath c = a capp b


log close
exit  /*
program drop _all

set traced 8
set tracehilite "margins" , word
set trace off
capture log close _all
log using matwork, replace text

version 12.1
clear all
macro drop _all
set linesize 80
set scheme sj

program drop _all

//  or and dc plot
sysuse nomocc4, clear
mlogit occ i.white ed exper, baseoutcome(5) nolog
    _mchange_end[15,5]
    _mchange_start[15,5]
    _mchange_pvalue[15,5]
    _mchange_se[15,5]
    _mchange_z[15,5]
    _mchange_ll[15,5]
    _mchange_ul[15,5]
    _mchange_dc[15,5]
*/
/*
mchange, atmeans
mat dir
matwork _mchange_start minus _mchange_end equals diff
*/

matrix dog = _mchange_dc
rowwork 2 - 2 = 3 in dog
rowwork 2 - 2 = 20 in dog

exit
set trace off
mat indx = (1, 3, 5)'
matwork _mchange_start index indx equals sel

log close
exit
